(load "../lang/dlambda.lisp")

(defun interest-compounder (initial-principal initial-interest-rate)
  (let ((private) (public)
        (principal initial-principal)
        (interest-rate initial-interest-rate)
        (years-passed 0))

    (setf private
      (eval
        (dlambda

          (:add-years (years)
            (if (> years 0)
              (setf years-passed (+ years-passed years))))

          (:percent-of-number (n percentage)
            (if (> percentage 0)
              (/ (+ (* n percentage) 50) 100)
              (/ (- (* n percentage) 50) 100)))

          (:compound-interest (years)
            (if (> years 0)
              (progn
                (setf principal
                  (+ principal
                    (call private :percent-of-number principal interest-rate)))
                (call private :compound-interest (- years 1))))))))

    (setf public
      (eval
        (dlambda

          (:get-years-passed ()
            years-passed)

          (:get-principal ()
            principal)

          (:get-interest-rate ()
            interest-rate)

          (:set-interest-rate (new-interest-rate)
            (setf interest-rate new-interest-rate))

          (:move-forward-years (years)
            (progn
              (call private :add-years years)
              (call private :compound-interest years))))))))
